import { Swagger, OpenAPI, SwaggerlintRule, SwaggerlintConfig, LintError } from './types';
declare type ValidSample<Schema> = {
    it: string;
    schema: Partial<Schema>;
    config?: SwaggerlintConfig;
}[];
declare type InvalidSample<Schema> = {
    it: string;
    schema: Partial<Schema>;
    config?: SwaggerlintConfig;
    errors: Partial<LintError>[];
}[];
declare type Item<T> = {
    valid: ValidSample<T>;
    invalid: InvalidSample<T>;
};
export declare class RuleTester {
    rule: SwaggerlintRule<string>;
    defaultConfig: SwaggerlintConfig;
    constructor(rule: SwaggerlintRule<string>);
    run({ swagger, openapi, }: {
        swagger?: Item<Swagger.SwaggerObject>;
        openapi?: Item<OpenAPI.OpenAPIObject>;
    }): void;
}
export {};
