"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../../utils");
const name = 'no-external-refs';
const rule = utils_1.createRule({
    name,
    docs: {
        recommended: false,
        description: 'Forbids the usage of external ReferenceObjects',
    },
    meta: {
        messages: {
            msg: 'External references are banned.',
        },
    },
    openapiVisitor: {
        ReferenceObject: ({ node, report }) => {
            if (!node.$ref.startsWith('#')) {
                report({ messageId: 'msg' });
            }
        },
    },
});
exports.default = rule;
