"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../../utils");
const name = 'path-param-required-field';
const messages = {
    requiredField: 'Parameter "{{name}}" is missing "required" property',
};
function ParameterObject({ node, report }) {
    if (!('required' in node)) {
        report({
            messageId: 'requiredField',
            data: {
                name: node.name,
            },
        });
    }
}
const rule = utils_1.createRule({
    name,
    docs: {
        recommended: false,
        description: 'Helps to keep consistently set optional `required` property in path parameters',
    },
    meta: {
        messages,
    },
    swaggerVisitor: {
        ParameterObject,
    },
    openapiVisitor: {
        ParameterObject,
    },
});
exports.default = rule;
