"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.capitalize = exports.omit = exports.isObject = exports.hasKey = exports.newerHttpMethods = exports.oldHttpMethods = void 0;
exports.oldHttpMethods = [
    'get',
    'put',
    'post',
    'delete',
    'options',
    'head',
    'patch',
];
exports.newerHttpMethods = [...exports.oldHttpMethods, 'trace'];
function hasKey(key, obj) {
    return key in obj;
}
exports.hasKey = hasKey;
function isObject(arg) {
    return typeof arg === 'object' && arg !== null && !Array.isArray(arg);
}
exports.isObject = isObject;
function omit(src, fields) {
    const toOmit = new Set(fields);
    return Object.keys(src).reduce((acc, key) => {
        if (toOmit.has(key))
            return acc;
        // @ts-expect-error: shallow copying an object
        acc[key] = src[key];
        return acc;
    }, {});
}
exports.omit = omit;
function capitalize(str) {
    return str.charAt(0).toUpperCase() + str.slice(1);
}
exports.capitalize = capitalize;
