import { SwaggerVisitorName, SwaggerlintRule } from '../types';
export * from './common';
export declare const log: (x: string) => void;
export declare function isValidSwaggerVisitorName(name: string): name is SwaggerVisitorName;
declare type ValidCasesObj = {
    camel: Set<'camel' | 'lower'>;
    constant: Set<'constant'>;
    kebab: Set<'kebab' | 'lower'>;
    pascal: Set<'pascal'>;
    snake: Set<'snake' | 'lower'>;
};
export declare const validCases: ValidCasesObj;
export declare function isValidCaseName(name: string | void): name is keyof typeof validCases;
export declare function createRule<T extends string>(rule: SwaggerlintRule<T>): typeof rule;
