"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createRule = exports.isValidCaseName = exports.validCases = exports.isValidSwaggerVisitorName = exports.log = void 0;
__exportStar(require("./common"), exports);
const validate_json_1 = require("./validate-json");
const isDev = process.env.NODE_ENV === 'development';
exports.log = isDev
    ? (x) => console.log(`--> ${x}`)
    : () => null;
/**
 * TODO: extract swagger v2 specific utils into separate file
 */
const swaggerVisitorSet = new Set([
    'SwaggerObject',
    'InfoObject',
    'PathsObject',
    'DefinitionsObject',
    'ParametersDefinitionsObject',
    'ResponsesDefinitionsObject',
    'SecurityDefinitionsObject',
    'SecuritySchemeObject',
    'ScopesObject',
    'SecurityRequirementObject',
    'TagObject',
    'ExternalDocumentationObject',
    'ContactObject',
    'LicenseObject',
    'PathItemObject',
    'OperationObject',
    'ParameterObject',
    'ResponsesObject',
    'ReferenceObject',
    'ResponseObject',
    'SchemaObject',
    'XMLObject',
    'HeadersObject',
    'HeaderObject',
    'ItemsObject',
    'ExampleObject',
]);
function isValidSwaggerVisitorName(name) {
    return swaggerVisitorSet.has(name);
}
exports.isValidSwaggerVisitorName = isValidSwaggerVisitorName;
exports.validCases = {
    camel: new Set(['camel', 'lower']),
    constant: new Set(['constant']),
    kebab: new Set(['kebab', 'lower']),
    pascal: new Set(['pascal']),
    snake: new Set(['snake', 'lower']),
};
function isValidCaseName(name) {
    return typeof name === 'string' && name in exports.validCases;
}
exports.isValidCaseName = isValidCaseName;
const ruleJsonSchema = {
    type: 'object',
    required: ['name'],
    properties: {
        name: {
            type: 'string',
        },
        meta: {
            type: 'object',
            properties: {
                messages: {
                    type: 'object',
                },
                schema: {
                    type: 'object',
                },
            },
        },
        openapiVisitor: {
            type: 'object',
        },
        swaggerVisitor: {
            type: 'object',
        },
    },
    additionalProperties: true,
};
function createRule(rule) {
    const errors = validate_json_1.validate(ruleJsonSchema, rule);
    if (errors[0])
        throw errors[0];
    return rule;
}
exports.createRule = createRule;
