"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.componentsKeys = exports.isValidOpenAPIObject = exports.isValidVisitorName = exports.isRef = exports.httpMethods = void 0;
const common_1 = require("./common");
exports.httpMethods = common_1.newerHttpMethods;
function isRef(arg) {
    return typeof arg.$ref === 'string';
}
exports.isRef = isRef;
const openapiVisitorSet = new Set([
    'CallbackObject',
    'ComponentsObject',
    'ContactObject',
    'DiscriminatorObject',
    'EncodingObject',
    'ExampleObject',
    'ExternalDocumentationObject',
    'HeaderObject',
    'InfoObject',
    'LicenseObject',
    'LinkObject',
    'MediaTypeObject',
    'OAuthFlowObject',
    'OAuthFlowsObject',
    'OpenAPIObject',
    'OperationObject',
    'ParameterObject',
    'PathItemObject',
    'PathsObject',
    'ReferenceObject',
    'RequestBodyObject',
    'ResponseObject',
    'ResponsesObject',
    'SchemaObject',
    'SecurityRequirementObject',
    'SecuritySchemeObject',
    'ServerObject',
    'ServerVariableObject',
    'SpecificationExtensions',
    'TagObject',
    'XMLObject',
]);
function isValidVisitorName(name) {
    return openapiVisitorSet.has(name);
}
exports.isValidVisitorName = isValidVisitorName;
function isValidOpenAPIObject(arg) {
    return (common_1.isObject(arg) &&
        common_1.hasKey('openapi', arg) &&
        typeof arg.openapi === 'string' &&
        ['3.0.0', '3.0.1', '3.0.2', '3.0.3'].includes(arg.openapi));
}
exports.isValidOpenAPIObject = isValidOpenAPIObject;
exports.componentsKeys = [
    'schemas',
    'responses',
    'parameters',
    'examples',
    'requestBodies',
    'headers',
    'securitySchemes',
    'links',
    'callbacks',
];
