"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isSwaggerObject = exports.isInfoObject = exports.isRef = exports.httpMethods = void 0;
const common_1 = require("./common");
exports.httpMethods = common_1.oldHttpMethods;
function isRef(arg) {
    return typeof arg.$ref === 'string';
}
exports.isRef = isRef;
function isInfoObject(arg) {
    return (common_1.isObject(arg) &&
        common_1.hasKey('title', arg) &&
        common_1.hasKey('version', arg) &&
        typeof arg.title === 'string' &&
        typeof arg.version === 'string');
}
exports.isInfoObject = isInfoObject;
function isSwaggerObject(arg) {
    return (common_1.isObject(arg) &&
        common_1.hasKey('swagger', arg) &&
        arg.swagger === '2.0' &&
        common_1.hasKey('info', arg) &&
        common_1.hasKey('paths', arg) &&
        common_1.isObject(arg.paths) &&
        isInfoObject(arg.info));
}
exports.isSwaggerObject = isSwaggerObject;
